数组中重复的数字

链接:https://www.nowcoder.com/questionTerminal/623a5ac0ea5b4e5f95552655361ae0a8
来源:牛客网

  • 热度指数:71901  时间限制:1秒 空间限制:32768K

在一个长度为n的数组里的所有数字都在0到n-1的范围内。 数组中某些数字是重复的,但不知道有几个数字是重复的。也不知道每个数字重复几次。请找出数组中任意一个重复的数字。 例如,如果输入长度为7的数组{2,3,1,0,2,5,3},那么对应的输出是第一个重复的数字2。

分析:循环遍历数组,使用HashMap<Integer,Integer>存储数组中的数,key存数组中的数,value数组中数字出现的次数,因为key是唯一的,所以当数组中的数字在HashMap中出现时将该数保存在duplication[0]中,并返回true。

import java.util.HashMap;
public class Solution {
    // Parameters:
    //    numbers:     an array of integers
    //    length:      the length of array numbers
    //    duplication: (Output) the duplicated number in the array number,length of duplication array is 1,so using duplication[0] = ? in implementation;
    //                  Here duplication like pointor in C/C++, duplication[0] equal *duplication in C/C++
    //    这里要特别注意~返回任意重复的一个,赋值duplication[0]
    // Return value:       true if the input is valid, and there are some duplications in the array number
    //                     otherwise false
    public boolean duplicate(int numbers[],int length,int [] duplication) {
    	HashMap<Integer,Integer> hashMap = new HashMap<Integer,Integer>();
        for(int i = 0 ;i < length ;i++){
            if(hashMap.containsKey(numbers[i])){
                duplication[0] = numbers[i];
                return true;
            }else{
                hashMap.put(numbers[i],1);
            }
        }
        return false;
    }
}

思路2:因为题目中没有要求统计重复数字出现的次数,所以没必要用HashMap,Set是一个不包含重复元素的collection,所以用Set就可以解决该问题。

import java.util.HashSet;


public class Solution{

	public static boolean duplicate(int numbers[], int length, int[] duplication) {
		HashSet<Integer> hashSet = new HashSet<>();
		for (int i = 0; i < length; i++) {
			if (hashSet.contains(numbers[i])) {
				duplication[0] = numbers[i];
				return true;
			} else {
				hashSet.add(numbers[i]);
			}
		}
		return false;
	}
}

 

思路3:参考Aurora1的思路,这种方法很好的利用了题目中给的信息,长度为n的数组里的所有数字都在0到n-1的范围内,定义一个boolean数组,数组中的数字为该boolean数组的索引。

 

public class Solution {
	public boolean duplicate(int numbers[],int length,int [] duplication) {                                                                     boolean[] k = new boolean[length];
	for(int  i= 0;i < length;i++){
			if(k[numbers[i]] == true){
				duplication[0] = numbers[i];
				return true;
			}
			k[numbers[i]] = true;
		}
		return false;
	}
}

 

 

 

 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值